package ksnet.kspay;

import java.io.*;
import java.net.*;
import java.util.*;
import  java.text.SimpleDateFormat;

import java.sql.*;

public class FirmBypassDB extends Thread
{
	public static boolean USE_DEBUG = false;
	
	private String msg_info[] = new String[10];
	
	public static void main(String[] args) throws Exception
	{
		CUtil.setConfig(args[0]);
		

	        String DEBUG_MODE= CUtil.get("DEBUG");
	        if (DEBUG_MODE != null && DEBUG_MODE.equalsIgnoreCase("true")) FirmBypassDB.USE_DEBUG = true;
	        else  FirmBypassDB.USE_DEBUG = false;

		long SLEEP_TIME = Long.parseLong(CUtil.get("SLEEP_TIME"));
		long THREAD_DELAY_TIME = Long.parseLong(CUtil.get("THREAD_DELAY_TIME"));
	        
	        while(true)
	        {
	 			String  send_info[] = DUtil.Select_SendData();

	 			if (send_info[0].equals("0000"))
	 			{
	 				new FirmBypassDB(send_info).start();
					Thread.sleep(THREAD_DELAY_TIME);
				}
				else /* û Ÿ  */
				{
					Thread.sleep(SLEEP_TIME);
				}
	       	 
	        }
	}

	public FirmBypassDB(String[] send_info)
	{
		System.arraycopy(send_info, 0, this.msg_info, 0, send_info.length); 
	}

	public void run()
	{
		DataOutputStream	cli_out			= null;
		DataInputStream		cli_in			= null;
		DataOutputStream	serv_out		= null;
		DataInputStream		serv_in			= null;
		String			msg	= null;
		String 			host;
		int 			port, timeout;
		int				msg_len = 0;
		int				len;
		Socket ss = null;
		
		byte[]	byte_buf = new byte[1024];
		byte[]	sbuf = new byte[1024];
		byte[]	rbuf = new byte[1024];
		int		read_len = 0, rest_len = 0, rtn_len = 0;
		
		try {
			

			host = CUtil.get("KSNET_IP");

			/* FCS */
			if (this.msg_info[6].substring(17,19).equals("99") || this.msg_info[6].substring(84,87).equals("099"))
				port = Integer.parseInt(CUtil.get("KSNET_FCS_Port"));
			/* ü */
			else
				port = Integer.parseInt(CUtil.get("KSNET_Port"));

			timeout = Integer.parseInt(CUtil.get("Timeout"));
			msg_len = Integer.parseInt(CUtil.get("MSG_LENGTH"));

			this.msg_info[0] = "9999";
			this.msg_info[7] = " ";
			byte_buf = this.msg_info[6].getBytes();
			msg = SUtil.toHanX(byte_buf, 0, msg_len);
			LUtil.println("CLIENT->DAEMON=[" + msg + "]");
			
			sbuf = msg.getBytes();
			
			/* KSNET ۽ */
			ss		=	new Socket();
			ss.connect(new InetSocketAddress(host, port),2*1000);//connect timeout	
			ss.setSoTimeout(timeout*1000);//read timeout
			
			serv_out = new DataOutputStream(ss.getOutputStream());
			serv_out.write(sbuf, 0, msg_len);
			serv_out.flush();
			LUtil.println("DAEMON->KSNET =[" + msg + "]");
			
			
			/* KSNETκ  */
			serv_in = new DataInputStream(ss.getInputStream());
			
			msg = null; 
			read_len = 0;
			rtn_len = 0;
			
			if (msg_len != (rtn_len = serv_in.read(rbuf, read_len, msg_len)))
			{
				throw new IOException("Read(recv) error - (" + read_len + ")!!");
			}
			

			read_len = read_len + rtn_len;
			msg = SUtil.toHanX(rbuf, 0, read_len);
			LUtil.println("KSNET ->DAEMON=[" + msg + "]");


			this.msg_info[0] = "0000";
			this.msg_info[7] = msg;
			DUtil.Update_RecvData(this.msg_info);
			 			
			LUtil.println("DAEMON->CLIENT=[" + msg + "]");	
			
		}catch(SocketTimeoutException e) {
			this.msg_info[0] = "7777";
			DUtil.Update_RecvData(this.msg_info);
			LUtil.println(e.getMessage());
		}catch (Exception e) {
			this.msg_info[0] = "8888";
			DUtil.Update_RecvData(this.msg_info);
			LUtil.println(e.getMessage());
		}finally {
			try{if (serv_in != null) serv_in.close();}catch(Exception e){};
			try{if (serv_out != null) serv_out.close();}catch(Exception e){};
			try{if (ss != null) ss.close();}catch(Exception e){};
		}
	}

}

class MsgSaf extends TimerTask
{
	public MsgSaf ()
	{
		;
	}

	public void run()
	{
		;
	}
}

class LUtil
{
	static String LOG_DIR = null;
	private static synchronized boolean init()
	{
		if (null == LOG_FILE || CUtil.isNew())
		{
			LOG_DIR		= CUtil.get("LogDirPath"	);
			
			if (null == LOG_DIR) return false;
		}
		return true;
	}

	static Calendar LOG_CAL		= Calendar.getInstance();
	static String  LOG_DT		= null;
	static String  LOG_FILE		= null;
	
	private static synchronized void day_check(String curr_dt8)
	{
		if (LOG_DT == null || !LOG_DT.equals(curr_dt8))
		{
			/*
			File log_dir_file = new File(LOG_DIR, "log");
			if (!log_dir_file.exists())log_dir_file. mkdir();
			*/

			StringBuffer sb = new StringBuffer();
			
			sb.append(LOG_DIR);
			if (!LOG_DIR.endsWith("/") && !LOG_DIR.endsWith("\\")) sb.append('/');
			/*
			sb.append("log/");
			*/
			sb.append(curr_dt8);
			sb.append(".log");
			
			LOG_FILE = sb.toString();
			
			LOG_DT = curr_dt8;
		}
	}
	
	public static void println(Object pstr)
	{
		if (!init())
		{
			System.out.println("LogDirPath !!");
			return;
		}
		
		String curr_date = SUtil.getCurrDate();
		
		day_check(curr_date.substring(0,8));

		File openFile = new File(LOG_FILE);
		PrintStream out = null;

		try{
			if(openFile.exists()){
				out = new PrintStream(new FileOutputStream(LOG_FILE, true), true);
			}else{
				out = new PrintStream(new FileOutputStream(LOG_FILE), true);
			}
		}catch(Exception e)
		{
			e.printStackTrace();
		}
		
		if (pstr instanceof Throwable)
		{
			Throwable tw = (Throwable)pstr;
			tw.printStackTrace(out);
			out.println();
		}else
		{
			StringBuffer sb = new StringBuffer();
			
			sb.append("[");
			sb.append(curr_date.substring(8,10)).append(":").append(curr_date.substring(10,12)).append(":").append(curr_date.substring(12,14));
			sb.append("]" );
			sb.append(pstr);
			
			out.println(sb.toString());
		}
		
		out.close();
	}

}

class CUtil
{
	static String config_file = null;
	static long lastModified  = 0;
	
	public static Properties props = new Properties();
	
	public static synchronized void setConfig(String fpath)
	{
		if (!new File(fpath).exists()) throw new IllegalArgumentException("ȯϰο=["+fpath+"]");
		config_file = fpath;
	}
	
	public static synchronized boolean isNew()
	{
		try
		{
			File f = new File(config_file);
			long m_lastModified = f.lastModified();
			
			if (m_lastModified > lastModified + 2000)
			{
				props.load(new FileInputStream(f));
				
				lastModified = m_lastModified;

				return true;
			}
		}catch(Exception e)
		{
			e.printStackTrace();
		}
		return false;
	}
	
	public static String get(String kStr)
	{
		isNew();
		return props.getProperty(kStr);
	}
}

class DUtil
{
	static String DRIVER_NAME	= null;
	static String DB_URL		= null;
	static String USER_NAME		= "";
	static String PASSWORD		= "";
	static String TABLE_NAME	= "";
	
	public static Connection getConnection()
	{
		if (null == DRIVER_NAME || CUtil.isNew())
		{
			DRIVER_NAME		= CUtil.get("JDBC_DRIVER"	);
			DB_URL			= CUtil.get("JDBC_URL"		);
			USER_NAME		= CUtil.get("JDBC_USER"		);
			PASSWORD		= CUtil.get("JDBC_PASSWORD"	);

			if (USER_NAME	== null) USER_NAME	= "";
			if (PASSWORD	== null) PASSWORD	= "";
		}
				
		try{
			Class.forName (DRIVER_NAME);
			if (USER_NAME == null || USER_NAME.length() == 0)
				return DriverManager.getConnection(DB_URL);
			else
				return DriverManager.getConnection(DB_URL, USER_NAME, PASSWORD);
		}catch(Exception e)
		{
			LUtil.println(e);
		}
		return null;
	}
	/* ó*/
	public static boolean Update_RecvData(String[] msg_info)
	{
		Connection		  con	 = null;
		PreparedStatement   pstmt   = null;
		String recv_flag = " ";
		String RecvDate		= new SimpleDateFormat("yyyyMMddHHmmss").format(new java.util.Date());
		TABLE_NAME		= CUtil.get("JDBC_TABLENAME"	);
		
		if (msg_info[0].equals("0000")) recv_flag = "Y";
		else if (msg_info[0].equals("7777")) recv_flag = "T";
		else  recv_flag = "F";
		
		String QRY = "UPDATE "+TABLE_NAME+" SET RECV_FLAG = ?,  RECV_DATE = ?, RECV_TIME = ?, RECV_MSG = ? WHERE REQ_DATE = ? AND BANK_CD = ? AND COMP_CODE = ? AND SEQ_NO = ? AND MSG_CD = ? AND SEND_FLAG = 'Y' AND RECV_FLAG = 'N' ";

		int cnt =0;
		try {
			con = getConnection();
			con.setAutoCommit(false);

			pstmt   = con.prepareStatement(QRY);

			pstmt.setString	(1, recv_flag		);
			pstmt.setString	(2, RecvDate.substring(0,8)		);
			pstmt.setString	(3, RecvDate.substring(8,14)		);
			pstmt.setString	(4, msg_info[7]		);
			pstmt.setString	(5, msg_info[1]		);
			pstmt.setString (6, msg_info[2]		);
			pstmt.setString	(7, msg_info[3]		);
			pstmt.setString	(8, msg_info[4]		);
			pstmt.setString	(9, msg_info[5]		);

			cnt	 = pstmt.executeUpdate();

			con.commit();
			return true;

		} catch(Throwable t) {
			t.printStackTrace();

		} finally {
			try {if(pstmt!=null){pstmt.close();pstmt= null;}}catch(Exception e){}
			try {if(con !=null) {con.close( );/*con = null;*/}}catch(Exception e){}
		}
		return false;
	} 

	/* ûŸ */
	public static String[]  Select_SendData ()
	{
		Connection			con		= null;
		PreparedStatement	pstmt	= null;
		ResultSet			rs		= null;
		int 			cnt 	= 0;
		String send_info[]= {"9999", " ", " ", " ", " ", " ", " ", " "} ;
		String RequestDate		= new SimpleDateFormat("yyyyMMddHHmmss").format(new java.util.Date());
		TABLE_NAME		= CUtil.get("JDBC_TABLENAME"	);
		
		String QRY = "SELECT REQ_DATE, BANK_CD, COMP_CODE, SEQ_NO, MSG_CD,  SEND_MSG  FROM " + TABLE_NAME + " WHERE REQ_DATE = ? AND SEND_FLAG = 'N' ORDER BY REQ_DATE, REQ_TIME";

		try {
			con = getConnection();
			con.setAutoCommit(false);

			pstmt = con.prepareStatement(QRY);

			pstmt.setString (1, RequestDate.substring(0,8) );

			rs = pstmt.executeQuery();

			while (rs.next()) {
				cnt++;
				send_info[0] = "0000";			
				send_info[1] = rs.getString(1); /* û */
				send_info[2] = rs.getString(2); /* ڵ */
				send_info[3] = rs.getString(3); /* üڵ */
				send_info[4] = rs.getString(4); /* ȣ */
				send_info[5] = rs.getString(5); /* Ÿ */
				send_info[6] = rs.getString(6); /* û */
				
				if (cnt >= 1) break; /* 1Ǿ  */
			}
			
			if (cnt < 1) 
			{
				send_info[0] = "1404";
			}
			else
			{
				pstmt.close(); pstmt= null;
								
				QRY = "UPDATE " + TABLE_NAME + " SET SEND_FLAG = 'Y', SEND_DATE = ?, SEND_TIME = ? WHERE REQ_DATE = ? AND BANK_CD = ? AND COMP_CODE = ? AND SEQ_NO= ? AND MSG_CD = ? ";
				
				pstmt = con.prepareStatement(QRY);

				pstmt.setString (1, RequestDate.substring(0,8) );
				pstmt.setString (2, RequestDate.substring(8,14) );
				pstmt.setString (3, send_info[1] );
				pstmt.setString (4, send_info[2] );
				pstmt.setString (5, send_info[3] );
				pstmt.setString (6, send_info[4] );
				pstmt.setString (7, send_info[5] );

				cnt	 = pstmt.executeUpdate();
				con.commit();
			}

		}catch(Throwable e) {
			send_info[0] = "9999";
			LUtil.println(e);

		} finally {
			try {if(pstmt!=null){pstmt.close();pstmt= null;}}catch(Exception e){}
			try {if(con !=null) {con.close( );/*con = null;*/}}catch(Exception e){}
			try {if(rs !=null) {rs.close( ); rs = null;}}catch(Exception e){}
		}
		return send_info;
	}
}


class SUtil
{
	static String getCurrDate()
	{
		Calendar cal = Calendar.getInstance();
		StringBuffer sb = new StringBuffer();
		int li_yyyy,li_MM,li_dd,li_hour,li_min,li_sec;
		
		li_yyyy = cal.get(Calendar.YEAR); li_MM = cal.get(Calendar.MONTH); li_dd = cal.get(Calendar.DATE);		
		li_hour = cal.get(Calendar.HOUR_OF_DAY); li_min = cal.get(Calendar.MINUTE); li_sec = cal.get(Calendar.SECOND);
		
		sb.append(li_yyyy).append(li_MM<9 ? "0" : "").append(li_MM + 1).append(li_dd<10 ? "0" : "").append(li_dd);
		sb.append(li_hour<10 ? "0" : "").append(li_hour).append(li_min<10 ? "0" : "").append(li_min).append(li_sec<10 ? "0" : "").append(li_sec);
		
		return sb.toString();
	}
	
	static String toHanX(byte[] bsrc, int idx, int len)
	{
		String str = toHan(bsrc, idx, len);
		if (str == null) return null;

		return str;
	}

	/*
	static String toHan(byte[] bsrc, int idx, int len)
	{
		try
		{
			return new String(bsrc, idx, len ,"ksc5601");
		}catch(java.io.UnsupportedEncodingException ue){}
		
		return null;
	}
	*/
	static String toHan(byte[] bsrc, int idx, int len)
	{
		try
		{
		String str = new String(bsrc, "ksc5601");
		return format(str, len, 'X');
		}catch(java.io.UnsupportedEncodingException ue){}
		
		return null;
	}

	static String format(String str, int len, char ctype)
	{
		byte[] buff;
		int filllen = 0;

		String			trim_str = null;
		StringBuffer	sb = new StringBuffer();
								        
		buff = (str == null) ? new byte[0] : str.getBytes();
									        
		filllen = len - buff.length;
		if (filllen < 0)
		{
			for(int i=0, j=0; j<len-4; i++)//  ΰ ߶
			{
				j += (str.charAt(i) > 127) ? 2 : 1;
				sb.append(str.charAt(i));
			}
			trim_str = sb.toString();
			buff = trim_str.getBytes();
			filllen = len - buff.length;
		
			if (filllen <= 0) return new String(buff, 0, len);//  Ÿ...
			sb.setLength(0);
		}else
		{
			trim_str = str;
		}
			
		if(ctype == '9')	// ڿ 
		{
			for(int i = 0; i<filllen;i++) sb.append('0');            
			sb.append(trim_str);
		}else				// ڿ 
		{
			for(int i = 0; i<filllen;i++) sb.append(' ');
			sb.insert(0, trim_str);
		}
		return sb.toString();
	}

}
